package Java9.Detyra1;

abstract class Atleti {
	
    public int nrRendor;
	public String emri;
    public int mosha;
    public char gjinia;
    public int distanca;
    public int gjatesiaPistes;

    public Atleti(int nrRendor, String emri, int mosha, char gjinia, int distanca, int gjatesiaPistes) throws AtletiException {
        if (nrRendor < 0 || mosha < 0 || distanca < 0 || gjatesiaPistes < 100 || emri.isEmpty()) {
            throw new AtletiException("Atributet e dhëna janë të pavlefshme!");
        }

        this.nrRendor = nrRendor;
        this.emri = emri;
        this.mosha = mosha;
        this.gjinia = gjinia;
        this.distanca = distanca;
        this.gjatesiaPistes = gjatesiaPistes;
    }

    public int getNrRendor() {
        return nrRendor;
    }
    public void setNrRendor(int nrRendor)throws AtletiException {
    	if(nrRendor<0)
        	throw new AtletiException("Nr Rendor i dhene nuk eshte valid!");
    	this.nrRendor = nrRendor;
	}

    public String getEmri() {
        return emri;
    }

    public void setEmri(String emri)throws AtletiException {
        if(emri.isEmpty())
        	throw new AtletiException("Emri i dhene nuk eshte valid!");
    	this.emri = emri;
    }

    public int getMosha() {
        return mosha;
    }

    public void setMosha(int mosha) {
        this.mosha = mosha;
    }

    public char getGjinia() {
        return gjinia;
    }

    public void setGjinia(char gjinia) {
        this.gjinia = gjinia;
    }

    public int getDistanca() {
        return distanca;
    }

    public void setDistanca(int distanca) {
        this.distanca = distanca;
    }

    public int getGjatesiaPistes() {
        return gjatesiaPistes;
    }

    public void setGjatesiaPistes(int gjatesiaPistes) {
        this.gjatesiaPistes = gjatesiaPistes;
    }

    public abstract void garo();

    public String toString() {
        return nrRendor + " : " + emri + " " + gjinia + " " + mosha + " vjec";
    }
    
    public boolean isEqual(Object obj) {		
		if(obj instanceof Atleti) {
			Atleti s = (Atleti)obj;
			
			return s.getNrRendor() == this.nrRendor;
		}
		return false;		
	}
}