package Java9.Detyra1;

import java.util.ArrayList;
import java.util.Iterator;

public class Vrapimi {
    private int gjatesiaPistes;
    private ArrayList<Vrapuesi> atletet;
    private Iterator<Vrapuesi> iterator;
    
    public Vrapimi(int gjatesiaPistes) throws AtletiException {
        if (gjatesiaPistes < 100) {
            throw new AtletiException("Gjatesia e pistes duhet te jete së paku 100 metra.");
        }
        this.gjatesiaPistes = gjatesiaPistes;
        this.atletet = new ArrayList<>();
    }

    public void shtoAtletin(Vrapuesi atleti) throws AtletiException {
        if(atleti == null){
            throw new AtletiException("Atleti i painicializuar!");
        }
        else if(atletet.contains(atleti)){
        	throw new AtletiException("Atleti me nrRendor " + atleti.getNrRendor() + " ekziston tashme.");
        }
        else{
        	atletet.add(atleti);
        }
    }

    public void shtypAtletet() {
    	iterator = atletet.iterator();

        while(iterator.hasNext()){
            Atleti a = iterator.next();
            if(a instanceof Vrapuesi){                
                System.out.println(a);                
            }
        }
    }

    public void filloGaren() {
        for(int i=0; i<atletet.size(); i++) {
            Thread thread = new Thread(atletet.get(i));
            thread.start();
        }
    }

    public static void main(String[] args) {
        try {
            Vrapimi vrapimi = new Vrapimi(200);

            vrapimi.shtoAtletin(new Vrapuesi(1, "Atlet1", 25, 'M', 0, 100, 2));
            vrapimi.shtoAtletin(new Vrapuesi(2, "Atlet2", 28, 'F', 0, 100, 1));
            vrapimi.shtoAtletin(new Vrapuesi(3, "Atlet3", 30, 'M', 0, 100, 4));
            vrapimi.shtoAtletin(new Vrapuesi(4, "Atlet4", 22, 'F', 0, 100, 3));
            vrapimi.shtoAtletin(new Vrapuesi(5, "Atlet5", 26, 'M', 0, 100, 1));
            vrapimi.shtoAtletin(new Vrapuesi(6, "Atlet6", 24, 'F', 0, 100, 2));
            vrapimi.shtoAtletin(new Vrapuesi(7, "Atlet7", 29, 'M', 0, 100, 1));
            vrapimi.shtoAtletin(new Vrapuesi(8, "Atlet8", 27, 'F', 0, 100, 5));

            vrapimi.shtypAtletet();

            vrapimi.filloGaren();

        } catch (AtletiException e) {
            e.printStackTrace();
        }
    }
}
